#!/usr/bin/env python3
import sys

oldexcepthook = sys.excepthook
def newexcepthook(type,value,traceback):
	oldexcepthook(type,value,traceback)
	input("Press ENTER to quit.")
sys.excepthook = newexcepthook

import os
p = os.path.join
pUp = os.path.dirname
s = False
if getattr(sys, 'frozen', False) and hasattr(sys, '_MEIPASS'):
	s = os.path.realpath(sys.executable)
else:
	s = os.path.realpath(__file__)
sp = pUp(s)

# script start
import shutil

# settings
dist = 1.0 # global multiplier - applies to everything, in addition to the multipliers below
distWithLOD = 0.0 # multiplier for objects that have LODs
distWithoutLOD = 0.5 # multiplier for objects that don't have LODs
distLOD = 1.2 # multiplier for LOD objects (object contains "LOD" in name)

# prioritized pairs: path, distance multiplier
# if an ide file path contains the path from the pairs, the multiplier is used, in addition to the other multipliers
# the bottom entries have more priority
distFilters = [
	p("pc","data","maps","generic","procobj.ide"),0,
	p("pc","data","maps","props"),1.5,
	p("pc","data","maps","props","vegetation"),0.5,
	p("pc","data","maps","props","roadside","lamppost.ide"),0.5
]

inPath = p(sp,"in")
outPath = p(sp,"out")
# settings end

if os.path.isdir(outPath): shutil.rmtree(outPath)
os.makedirs(outPath)
for root,dirs,files in os.walk(inPath):
	for file in dirs:
		ffile = p(root,file)
		lfile = ffile.replace(inPath + os.path.sep,"",1)
		ofile = p(outPath,lfile)
		os.makedirs(ofile)
	
	for file in files:
		if not file.lower().endswith(".ide"): continue
		ffile = p(root,file)
		lfile = ffile.replace(inPath + os.path.sep,"",1)
		ofile = p(outPath,lfile)
		
		fMult = 1.0
		index = 0
		length = len(distFilters)
		while index < length:
			if distFilters[index] in lfile:
				fMult = distFilters[index + 1]
			index += 2
		
		ffileh = open(ffile,"r",encoding="utf-8")
		ofileh = open(ofile,"w",encoding="utf-8")
		
		category = False
		for line in ffileh:
			rline = line
			line = line.strip(" \t\r\n")
			line = line.split("#",1)
			#comment = line[1]
			line = line[0]
			if line == "":
				ofileh.write("\n")
				continue
			
			if not category:
				category = line.lower()
				ofileh.write(line+ "\n")
				continue
			
			if line.lower() == "end":
				category = False
				ofileh.write(line+ "\n")
				continue
			
			line = line.split(",")
			index = 0
			length = len(line)
			while index < length:
				line[index] = line[index].strip(" \t")
				index += 1
			
			handled = False
			if category in ["objs","tobj"]:
				handled = True
				nlength = 15
				if category == "tobj": nlength = 16
				hasLod = (line[-1] != "null")
				isLod = ("lod" in line[0].lower())
				distances = len(line) - nlength
				index = 0
				while index < distances:
					cMult = 1.0
					if not isLod:
						if hasLod:
							cMult = cMult * distWithLOD
						else:
							cMult = cMult * distWithoutLOD
					else:
						cMult = cMult * distLOD
					cMult = cMult * fMult
					cMult = cMult * dist
					outStr = str(float(line[index + 2]) * cMult).split("e")[0]
					outStr = outStr.split(".")
					if len(outStr) < 2: outStr.append("0")
					if len(outStr[1]) > 2: outStr[1] = outStr[1][:2]
					outStr = ".".join(outStr)
					line[index + 2] = outStr
					index += 1
			
			if handled:
				line = ", ".join(line) + "\n"
				ofileh.write(line)
			else:
				ofileh.write(rline)
		
		ofileh.close()
		ffileh.close()